package com.cvu.numsoft;

import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Pointcut;

@Aspect
public class AspectUtil {

	@Pointcut("execution(public * com.cvu.numsoft..*.*(..)) && !execution(public * com.cvu.numsoft.AspectUtil.*()) && !execution(public * com.cvu.numsoft..*.get*(..)) && !execution(public * com.cvu.numsoft..*.hashCode(..)) && !execution(public * com.cvu.numsoft..*.equals(..)) && !execution(public * com.cvu.numsoft..*.set*(..)) && !execution(public * com.cvu.numsoft..is*(..))")
	public void profile() {
	}

	@Around("profile()")
	public Object profiling(JoinPoint jp, ProceedingJoinPoint pjp)
			throws Throwable {
		long start = System.currentTimeMillis();
		Object ret = pjp.proceed();
		long end = System.currentTimeMillis();
		System.out.println(jp.getThis().getClass().getName() + "."
				+ jp.getSignature().getName() + " took " + (end - start)
				+ " miliseconds");
		return ret;
	}

}
